[![Twitter](https://badgen.net/badge/icon/dipdup_io?icon=twitter&label=)](https://twitter.com/dipdup_io)
[![GitHub stars](https://img.shields.io/github/stars/dipdup-io/dipdup?color=2c2c2c)](https://github.com/dipdup-io/dipdup)
[![PyPI monthly downloads](https://img.shields.io/pypi/dm/dipdup?color=2c2c2c)](https://pypi.org/project/dipdup/)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/dipdup?color=2c2c2c)](https://www.python.org)
[![License: MIT](https://img.shields.io/github/license/dipdup-io/dipdup?color=2c2c2c)](https://github.com/dipdup-io/dipdup/blob/next/LICENSE)
<br>
[![Latest stable release](https://img.shields.io/github/v/release/dipdup-io/dipdup?label=stable%20release&color=2c2c2c)](https://github.com/dipdup-io/dipdup/releases)
[![Latest pre-release](https://img.shields.io/github/v/release/dipdup-io/dipdup?include_prereleases&label=latest%20release&color=2c2c2c)](https://github.com/dipdup-io/dipdup/releases)
[![GitHub issues](https://img.shields.io/github/issues/dipdup-io/dipdup?color=2c2c2c)](https://github.com/dipdup-io/dipdup/issues)
[![GitHub pull requests](https://img.shields.io/github/issues-pr/dipdup-io/dipdup?color=2c2c2c)](https://github.com/dipdup-io/dipdup/pulls)

<h3 align="center"><img src="https://actual-docs.interface-1bp.pages.dev/_nuxt/logo.9b02ab5e.svg" alt="DipDup logo"></h3>

DipDup is a Python framework for building smart contract indexers. It helps developers focus on business logic instead of writing a boilerplate to store and serve data. DipDup-based indexers are selective, which means only required data is requested. This approach allows to achieve faster indexing times and decreased load on underlying APIs.

- **Ready to build your first indexer?** Head to [Quickstart](https://dipdup.io/docs/quickstart).

- **Looking for examples?** Check out [Demo Projects](https://dipdup.io/docs/examples/demos) and [Built with DipDup](https://dipdup.io/docs/examples/built-with-dipdup) pages.

- **Want to participate?** Vote for [open issues](https://github.com/dipdup-io/dipdup/issues?q=is%3Aissue+is%3Aopen+sort%3Aupdated-desc), join [discussions](https://github.com/dipdup-io/dipdup/discussions) or [become a sponsor](https://github.com/sponsors/dipdup-io).

- **Have a question?** Join our [Discord](https://discord.gg/NbANhqCJHA) or tag @dipdup_io on [Twitter](https://twitter.com/dipdup_io).

This project is maintained by the [Baking Bad](https://bakingbad.dev/) team.
<br>
Development is supported by [Tezos Foundation](https://tezos.foundation/) and [OnlyDust](https://www.onlydust.xyz).

## Thanks

### Sponsors

Decentralized web requires decentralized funding. The following people and organizations help the project to be sustainable.

- [@dansan566](https://github.com/dansan566)
- [@royscheeren](https://github.com/royscheeren)

Want your project to be listed here? We have nice perks for sponsors! Visit our [GitHub Sponsors page](https://github.com/sponsors/dipdup-io).

### Contributors

We are grateful to all the people who help us with the project.

- [@852Kerfunkle](https://github.com/852Kerfunkle)
- [@Anshit01](https://github.com/Anshit01)
- [@arrijabba](https://github.com/arrijabba)
- [@Fitblip](https://github.com/Fitblip)
- [@gdsoumya](https://github.com/gdsoumya)
- [@herohthd](https://github.com/herohthd)
- [@Karantezsure](https://github.com/Karantezsure)
- [@mystdeim](https://github.com/mystdeim)
- [@nikos-kalomoiris](https://github.com/nikos-kalomoiris)
- [@pravind](https://github.com/pravind)
- [@sbihel](https://github.com/sbihel)
- [@tezosmiami](https://github.com/tezosmiami)
- [@tomsib2001](https://github.com/tomsib2001)
- [@veqtor](https://github.com/veqtor)
- [@xflpt](https://github.com/xflpt)

If we forgot to mention you, or you want to update your record, please, open an issue or pull request.
